/* Generated By:JJTree: Do not edit this line. OMethodCall.java Version 4.3 */
/* JavaCCOptions:MULTI=true,NODE_USES_PARSER=false,VISITOR=true,TRACK_TOKENS=true,NODE_PREFIX=O,NODE_EXTENDS=,NODE_FACTORY=,SUPPORT_CLASS_VISIBILITY_PUBLIC=true */
package com.orientechnologies.orient.core.sql.parser;

import com.orientechnologies.orient.core.command.OCommandContext;
import com.orientechnologies.orient.core.db.ODatabaseDocumentInternal;
import com.orientechnologies.orient.core.db.ODatabaseRecordThreadLocal;
import com.orientechnologies.orient.core.db.record.OIdentifiable;
import com.orientechnologies.orient.core.exception.OCommandExecutionException;
import com.orientechnologies.orient.core.sql.OSQLEngine;
import com.orientechnologies.orient.core.sql.executor.OResult;
import com.orientechnologies.orient.core.sql.executor.OResultInternal;
import com.orientechnologies.orient.core.sql.functions.OSQLFunction;
import com.orientechnologies.orient.core.sql.functions.OSQLFunctionFiltered;
import com.orientechnologies.orient.core.sql.method.OSQLMethod;

import java.util.*;
import java.util.stream.Collectors;

public class OMethodCall extends SimpleNode {

  static Set<String> graphMethods = new HashSet<String>(
      Arrays.asList(new String[] { "out", "in", "both", "outE", "inE", "bothE", "bothV", "outV", "inV" }));

  static Set<String> bidirectionalMethods = new HashSet<String>(
      Arrays.asList(new String[] { "out", "in", "both", "oute", "ine", "inv", "outv", "bothe", "bothv" }));

  protected OIdentifier methodName;
  protected List<OExpression> params = new ArrayList<OExpression>();

  private Boolean calculatedIsGraph = null;

  public OMethodCall(int id) {
    super(id);
  }

  public OMethodCall(OrientSql p, int id) {
    super(p, id);
  }

  public void toString(Map<Object, Object> params, StringBuilder builder) {
    builder.append(".");
    methodName.toString(params, builder);
    builder.append("(");
    boolean first = true;
    for (OExpression param : this.params) {
      if (!first) {
        builder.append(", ");
      }
      param.toString(params, builder);
      first = false;
    }
    builder.append(")");
  }

  public boolean isBidirectional() {
    return bidirectionalMethods.contains(methodName.getStringValue().toLowerCase(Locale.ENGLISH));
  }

  public Object execute(Object targetObjects, OCommandContext ctx) {
    return execute(targetObjects, ctx, methodName.getStringValue(), params, null);
  }

  public Object execute(Object targetObjects, Iterable<OIdentifiable> iPossibleResults, OCommandContext ctx) {
    return execute(targetObjects, ctx, methodName.getStringValue(), params, iPossibleResults);
  }

  private Object execute(Object targetObjects, OCommandContext ctx, String name, List<OExpression> iParams,
      Iterable<OIdentifiable> iPossibleResults) {
    List<Object> paramValues = new ArrayList<Object>();
    Object val = ctx.getVariable("$current");
    if (val == null && targetObjects == null) {
      return null;
    }
    for (OExpression expr : iParams) {
      if (val instanceof OIdentifiable) {
        paramValues.add(expr.execute((OIdentifiable) val, ctx));
      } else if (val instanceof OResult) {
        paramValues.add(expr.execute((OResult) val, ctx));
      } else if (targetObjects instanceof OIdentifiable) {
        paramValues.add(expr.execute((OIdentifiable) targetObjects, ctx));
      } else if (targetObjects instanceof OResult) {
        paramValues.add(expr.execute((OResult) targetObjects, ctx));
      } else {
        throw new OCommandExecutionException("Invalild value for $current: " + val);
      }
    }
    if (isGraphFunction()) {
      OSQLFunction function = OSQLEngine.getInstance().getFunction(name);
      if (function instanceof OSQLFunctionFiltered) {
        Object current = ctx.getVariable("$current");
        if (current instanceof OResult) {
          current = ((OResult) current).getElement().orElse(null);
        }
        return ((OSQLFunctionFiltered) function)
            .execute(targetObjects, (OIdentifiable) current, null, paramValues.toArray(), iPossibleResults, ctx);
      } else {
        Object current = ctx.getVariable("$current");
        if (current instanceof OIdentifiable) {
          return function.execute(targetObjects, (OIdentifiable) current, null, paramValues.toArray(), ctx);
        } else if (current instanceof OResult) {
          return function.execute(targetObjects, ((OResult) current).getElement().orElse(null), null, paramValues.toArray(), ctx);
        } else {
          return function.execute(targetObjects, null, null, paramValues.toArray(), ctx);
        }
      }

    }
    OSQLMethod method = OSQLEngine.getMethod(name);
    if (method != null) {
      if (val instanceof OResult) {
        val = ((OResult) val).getElement().orElse(null);
      }
      return method.execute(targetObjects, (OIdentifiable) val, ctx, targetObjects, paramValues.toArray());
    }
    throw new UnsupportedOperationException("OMethod call, something missing in the implementation...?");

  }

  public Object executeReverse(Object targetObjects, OCommandContext ctx) {
    if (!isBidirectional()) {
      throw new UnsupportedOperationException();
    }

    String straightName = methodName.getStringValue();
    if (straightName.equalsIgnoreCase("out")) {
      return execute(targetObjects, ctx, "in", params, null);
    }
    if (straightName.equalsIgnoreCase("in")) {
      return execute(targetObjects, ctx, "out", params, null);
    }

    if (straightName.equalsIgnoreCase("both")) {
      return execute(targetObjects, ctx, "both", params, null);
    }

    if (straightName.equalsIgnoreCase("outE")) {
      return execute(targetObjects, ctx, "outV", params, null);
    }

    if (straightName.equalsIgnoreCase("outV")) {
      return execute(targetObjects, ctx, "outE", params, null);
    }

    if (straightName.equalsIgnoreCase("inE")) {
      return execute(targetObjects, ctx, "inV", params, null);
    }

    if (straightName.equalsIgnoreCase("inV")) {
      return execute(targetObjects, ctx, "inE", params, null);
    }

    if (straightName.equalsIgnoreCase("bothE")) {
      return execute(targetObjects, ctx, "bothV", params, null);
    }

    if (straightName.equalsIgnoreCase("bothV")) {
      return execute(targetObjects, ctx, "bothE", params, null);
    }

    throw new UnsupportedOperationException("Invalid reverse traversal: " + methodName);
  }

  public static ODatabaseDocumentInternal getDatabase() {
    return ODatabaseRecordThreadLocal.instance().get();
  }

  public boolean needsAliases(Set<String> aliases) {
    for (OExpression param : params) {
      if (param.needsAliases(aliases)) {
        return true;
      }
    }
    return false;
  }

  public OMethodCall copy() {
    OMethodCall result = new OMethodCall(-1);
    result.methodName = methodName.copy();
    result.params = params.stream().map(x -> x.copy()).collect(Collectors.toList());
    return result;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o)
      return true;
    if (o == null || getClass() != o.getClass())
      return false;

    OMethodCall that = (OMethodCall) o;

    if (methodName != null ? !methodName.equals(that.methodName) : that.methodName != null)
      return false;
    if (params != null ? !params.equals(that.params) : that.params != null)
      return false;

    return true;
  }

  @Override
  public int hashCode() {
    int result = methodName != null ? methodName.hashCode() : 0;
    result = 31 * result + (params != null ? params.hashCode() : 0);
    return result;
  }

  public void extractSubQueries(SubQueryCollector collector) {
    if (params != null) {
      for (OExpression param : params) {
        param.extractSubQueries(collector);
      }
    }
  }

  public boolean refersToParent() {
    if (params != null) {
      for (OExpression exp : params) {
        if (exp.refersToParent()) {
          return true;
        }
      }
    }
    return false;
  }

  public OResult serialize() {
    OResultInternal result = new OResultInternal();
    if (methodName != null) {
      result.setProperty("methodName", methodName.serialize());
    }
    if (params != null) {
      result.setProperty("items", params.stream().map(x -> x.serialize()).collect(Collectors.toList()));
    }
    return result;
  }

  public void deserialize(OResult fromResult) {
    if (fromResult.getProperty("methodName") != null) {
      methodName = OIdentifier.deserialize(fromResult.getProperty("methodName"));
    }
    if (fromResult.getProperty("params") != null) {
      List<OResult> ser = fromResult.getProperty("params");
      params = new ArrayList<>();
      for (OResult r : ser) {
        OExpression exp = new OExpression(-1);
        exp.deserialize(r);
        params.add(exp);
      }
    }
  }

  public boolean isCacheable() {
    if (isGraphFunction()) {
      return true;
    }
    return false;//TODO
  }

  private boolean isGraphFunction() {
    if (calculatedIsGraph != null) {
      return calculatedIsGraph;
    }
    for (String graphMethod : graphMethods) {
      if (graphMethod.equalsIgnoreCase(methodName.getStringValue())) {
        calculatedIsGraph = true;
        break;
      }
    }
    if (calculatedIsGraph == null) {
      calculatedIsGraph = false;
    }
    return calculatedIsGraph;
  }
}
/* JavaCC - OriginalChecksum=da95662da21ceb8dee3ad88c0d980413 (do not edit this line) */
